<!DOCTYPE html>
<html>

<head>
    <meta charset="UTF-8">
    <title>Desafio Menu</title>
    <link href="https://fonts.googleapis.com/css?family=Oswald" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet">
    <style>
        /* ... */
        * {
            box-sizing: border-box;
        }

        body {
            margin: 0;
            font-family: 'Oswald', sans-serif;
            background-color: lightgray;
        }

        .cabecalho {
            background: #333;
            border-bottom: solid 5px #4faddb;
            height: 80px;
            box-sizing: content-box;
        }

        .logo {
            display: inline-block;
            height: 80px;
            padding: 15px;
        }

        .logo img {
            height: 100%;
        }

        .menu-toggle {
            float: right;
            color: #eee;
            background-color: #555;
            border: solid 1px #777;
            border-radius: 5px;
            height: 40px;
            padding: 10px 20px;
            margin: 20px 15px;
        }

        .menu {
            display: inline-block;
            vertical-align: top;
            height: 80px;
            padding: 25px;
        }

        .menu ul {
            margin: 0;
            padding: 0;
        }

        .menu li {
            display: inline-block;
        }

        .cabecalho a {
            text-decoration: none;
            color: #eee;
            font-size: 1.3em;
        }

        .menu a {
            padding: 15px;
        }

        .autenticacao {
            float: right;
            height: 80px;
            padding: 25px;
        }

        .menu a:hover,
        .menu a.selected {
            background-color: #4faddb;
            color: #000;
        }

        .botao {
            border-radius: 30px;
            padding: 10px 25px;
            margin: 10px;
        }

        .destaque {
            background: #f50a31;
            color: #fff;
        }

        @media(min-width: 679px) {
            .menu-toggle {
                display: none;
            }
        }
        
        @media(max-width: 680px) {
            .menu {
                display: none;
            }
        }

        @media(max-width: 910px) {
            .autenticacao {
                display: none;
            }
        }
    </style>
</head>

<body>
    <header class="cabecalho">
        <div class="logo">
            <a href="#inicio">
                <img src="http://files.cod3r.com.br/curso-web/logo.png" alt="Logo" />
            </a>
        </div>
        <button class="menu-toggle">
            <i class="fa fa-lg fa-bars"></i>
        </button>
        <nav class="menu">
            <ul>
                <li>
                    <a href="#inicio">Início</a>
                </li>
                <li>
                    <a href="#cursos">Cursos</a>
                </li>
                <li>
                    <a href="#sobre">Sobre</a>
                </li>
                <li>
                    <a href="#contato">Contato</a>
                </li>
            </ul>
        </nav>
        <aside class="autenticacao">
            <a href="#login">Login</a>
            <a href="#registar" class="botao destaque">Registrar</a>
        </aside>
    </header>

    <script>
        window.onhashchange = function(e) {
            const oldUrl = e.oldURL.split('#')[1];
            const newUrl = e.newURL.split('#')[1];
            
            const oldLink = document.querySelector(`.menu a[href='#${oldUrl}']`);
            const newLink = document.querySelector(`.menu a[href='#${newUrl}']`);

            oldLink && oldLink.classList.remove('selected');
            newLink && newLink.classList.add('selected');
        }
    </script>
</body>

</html>